/**
	(module summary)

	License: $(LICENSE)
	Copyright: Copyright ©2007 Sönke Ludwig, All rights reserved.
	Authors: Sönke Ludwig
*/
module sfc.intf.win32.dshow;

version(Windows)
{
	//public import sfc.intf.win32.windows;
	public import sfc.intf.win32.oaidl;
	public import sfc.intf.win32.objidl;

	static string MIDL_INTERFACE( string guid ){
		return "/*"~guid~"*/"; // TODO !
	}

	version(Win32){} else { static assert(false, "Must be checked for non 32bit architecture"); }

	alias size_t DWORD_PTR;
	alias long LONGLONG;
	alias ulong DWORDLONG;
	alias const(IID)* REFIID;
	alias const(CLSID)* REFCLSID;
	alias DWORD LCID;
	alias int INT_PTR, LONG_PTR;
	alias LONG_PTR OAHWND;


	const {
		CLSID CLSID_CaptureGraphBuilder = GUID(0xBF87B6E0, 0x8C27, 0x11d0, [0xB3, 0xF0, 0x0, 0xAA, 0x00, 0x37, 0x61, 0xC5]);
		CLSID CLSID_CaptureGraphBuilder2 = GUID(0xBF87B6E1, 0x8C27, 0x11d0, [0xB3, 0xF0, 0x0, 0xAA, 0x00, 0x37, 0x61, 0xC5]);
		CLSID CLSID_ColorSpaceConverter = GUID(0x1643E180,0x90F5,0x11CE, [0x97, 0xD5, 0x00, 0xAA, 0x00, 0x55, 0x59, 0x5A]);
		CLSID CLSID_FilterGraph = GUID(0xe436ebb3, 0x524f, 0x11ce, [0x9f, 0x53, 0x00, 0x20, 0xaf, 0x0b, 0xa7, 0x70]);
		CLSID CLSID_NullRenderer = GUID(0xC1F400A4, 0x3F08, 0x11d3, [0x9F, 0x0B, 0x00, 0x60, 0x08, 0x03, 0x9E, 0x37]);
		CLSID CLSID_SystemDeviceEnum = GUID(0x62BE5D10,0x60EB,0x11d0,[0xBD,0x3B,0x00,0xA0,0xC9,0x11,0xCE,0x86]);
		CLSID CLSID_SampleGrabber = GUID(0xC1F400A0, 0x3F08, 0x11d3, [0x9F, 0x0B, 0x00, 0x60, 0x08, 0x03, 0x9E, 0x37]);
		CLSID CLSID_VideoInputDeviceCategory = GUID(0x860BB310,0x5D01,0x11d0,[0xBD,0x3B,0x00,0xA0,0xC9,0x11,0xCE,0x86]);

		IID IID_IAMStreamConfig = GUID(0xC6E13340, 0x30AC, 0x11d0, [0xA1, 0x8C, 0x00, 0xA0, 0xC9, 0x11, 0x89, 0x56]);
		IID IID_IBaseFilter = GUID(0x56a86895, 0x0ad4, 0x11ce, [0xb0, 0x3a, 0x00, 0x20, 0xaf, 0x0b, 0xa7, 0x70]);
		IID IID_ICaptureGraphBuilder2 = GUID(0x93E5A4E0, 0x2D50, 0x11d2, [0xAB, 0xFA, 0x00, 0xA0, 0xC9, 0xC6, 0xE3, 0x8D]);
		IID IID_ICreateDevEnum = GUID(0x29840822, 0x5B84, 0x11D0, [0xBD, 0x3B, 0x00, 0xA0, 0xC9, 0x11, 0xCE, 0x86]);
		IID IID_IFilterGraph = GUID(0x56a8689f, 0x0ad4, 0x11ce, [0xb0, 0x3a, 0x00, 0x20, 0xaf, 0x0b, 0xa7, 0x70]);
		IID IID_IGraphBuilder = GUID(0x56a868a9,0x0ad4,0x11ce,[0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70]);
		IID IID_IMediaControl = GUID(0x56a868b1,0x0ad4,0x11ce,[0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70]);
		IID IID_ISampleGrabber = GUID(0x6B652FFF, 0x11FE, 0x4fce, [0x92, 0xAD, 0x02, 0x66, 0xB5, 0xD7, 0xC7, 0x8F]);
		IID IID_ISampleGrabberCB = GUID(0x0579154A, 0x2B53, 0x4994, [0xB0, 0xD0, 0xE7, 0x73, 0x14, 0x8E, 0xFF, 0x85]);
		IID IID_ISpecifyPropertyPages = GUID(0xB196B28B, 0xBAB4, 0x101A, [0xB6, 0x9C, 0x00, 0xAA, 0x00, 0x34, 0x1D, 0x07]);
		IID IID_IVideoWindow = GUID(0x56a868b4, 0x0ad4, 0x11ce, [0xb0, 0x3a, 0x00, 0x20, 0xaf, 0x0b, 0xa7, 0x70]);

		GUID MEDIATYPE_Video = GUID(0x73646976, 0x0000, 0x0010, [0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71]);
		GUID MEDIASUBTYPE_RGB24 = GUID(0xe436eb7d, 0x524f, 0x11ce, [0x9f, 0x53, 0x00, 0x20, 0xaf, 0x0b, 0xa7, 0x70]);
		GUID FORMAT_VideoInfo = GUID(0x05589f80, 0xc356, 0x11ce, [0xbf, 0x01, 0x00, 0xaa, 0x00, 0x55, 0x59, 0x5a]);
		GUID PIN_CATEGORY_CAPTURE = GUID(0xfb6c4281, 0x0353, 0x11d1, [0x90, 0x5f, 0x00, 0x00, 0xc0, 0xcc, 0x16, 0xba]);
	}

	/////////////////////////////////
	// amvideo.h
	/////////////////////////////////
	struct VIDEOINFOHEADER {
		RECT            rcSource;          // The bit we really want to use
		RECT            rcTarget;          // Where the video should go
		DWORD           dwBitRate;         // Approximate bit data rate
		DWORD           dwBitErrorRate;    // Bit error rate for this stream
		REFERENCE_TIME  AvgTimePerFrame;   // Average time per frame (100ns units)

		BITMAPINFOHEADER bmiHeader;
	}

	/////////////////////////////////
	// devenum.idl
	/////////////////////////////////

	/*[
        object,
        uuid(29840822-5B84-11D0-BD3B-00A0C911CE86),
        pointer_default(unique)
	]*/
	interface ICreateDevEnum : IUnknown
	{
			HRESULT CreateClassEnumerator(
							/*[in]*/ REFCLSID clsidDeviceClass,
							/*[out]*/ IEnumMoniker* ppEnumMoniker,
							/*[in]*/ DWORD dwFlags);
	}


	/////////////////////////////////
	// strmif.idl
	/////////////////////////////////


	/////////////////////////////////
	// axcore.idl
	/////////////////////////////////

	alias LONGLONG REFERENCE_TIME;
	alias double REFTIME;
	alias DWORD_PTR HSEMAPHORE;
	alias DWORD_PTR HEVENT;

	enum PIN_DIRECTION {
		PINDIR_INPUT,
		PINDIR_OUTPUT
	}
	enum {
		MAX_PIN_NAME = 128,
		MAX_FILTER_NAME =128
	}

	/////////////////////////////////
	// axextend.idl
	/////////////////////////////////


	/////////////////////////////////
	//
	/////////////////////////////////


	/*[
			object,
			uuid(56a86897-0ad4-11ce-b03a-0020af0ba770),
			pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("56a86897-0ad4-11ce-b03a-0020af0ba770"));
	interface IReferenceClock : IUnknown {

		// get the time now
		HRESULT GetTime(
			/*out*/ REFERENCE_TIME *pTime
		);

		// ask for an async notification that a time has elapsed
		HRESULT AdviseTime(
			/*in*/ REFERENCE_TIME baseTime,       // base reference time
			/*in*/ REFERENCE_TIME streamTime,     // stream offset time
		/*in*/ HEVENT hEvent,                     // advise via this event
			/*out*/ DWORD_PTR * pdwAdviseCookie   // where your cookie goes
		);

		// ask for an async periodic notification that a time has elapsed
		HRESULT AdvisePeriodic(
			/*in*/ REFERENCE_TIME startTime,      // starting at this time
			/*in*/ REFERENCE_TIME periodTime,     // time between notifications
			/*in*/ HSEMAPHORE hSemaphore,         // advise via a semaphore
		/*out*/ DWORD_PTR * pdwAdviseCookie       // where your cookie goes
		);

		// cancel a request for notification
		HRESULT Unadvise(
			/*in*/ DWORD_PTR dwAdviseCookie);
	}

	/*[
	object,
	uuid(56a86899-0ad4-11ce-b03a-0020af0ba770),
	pointer_default(unique)
	]*/
	// possible states that the filter could be in
	enum FILTER_STATE {
		State_Stopped,            // not in use
		State_Paused,             // holding resources, ready to go
		State_Running             // actively processing media stream
	}
	mixin(MIDL_INTERFACE("56a86899-0ad4-11ce-b03a-0020af0ba770"));
	interface IMediaFilter : IPersist {

		// tell the filter to transition to the new state. The state transition
		// may not be instantaneous (external mechanical activity may be involved,
		// for example). The state functions may return before the state
		// transition has completed

		// these functions will return S_OK if the transition is complete, S_FALSE if
		// the transition is not complete but no error has occurred, or some error value
		// if the transition failed.
		HRESULT Stop();
		HRESULT Pause();

		// in order to synchronise independent streams, you must pass a time
		// value with the Run command. This is the difference between stream
		// time and reference time. That is, it is the amount to be added to
		// the IMediaSample timestamp to get the time at which that sample
		// should be rendered according to the reference clock.
		// If we are starting at the beginning of the stream, it will thus be
		// simply the time at which the first sample should appear. If we are
		// restarting from Paused mode in midstream, then it will be the total
		// time we have been paused added to the initial start time.

		// the filtergraph will provide this information to its filters. If you
		// are an app calling the filtergraph, it's ok to pass a start time of
		// 0, in which case the filter graph will calculate a soon-as-possible
		// time. FilterGraphs will accept 0 meaning ASAP; most filters will not.

		HRESULT Run(REFERENCE_TIME tStart);


		// find out what state the filter is in.
		// If timeout is 0, will return immediately - if a state transition is
		// not complete, it will return the state being transitioned into, and
		// the return code will be VFW_S_STATE_INTERMEDIATE.  if no state
		// transition is in progress the state will be returned and the return
		// code will be S_OK.
		//
		// If timeout is non-zero, GetState will not return until the state
		// transition is complete, or the timeout expires.
		// The timeout is in milliseconds.
		// You can also pass in INFINITE as a special value for the timeout, in
		// which case it will block indefinitely waiting for the state transition
		// to complete. If the timeout expires, the state returned is the
		// state we are trying to reach, and the return code will be
		// VFW_S_STATE_INTERMEDIATE. If no state transition is in progress
		// the routine returns immediately with return code S_OK.

		//
		// return State is State_Running, State_Paused or State_Stopped.
		// return code is S_OK, or VFW_S_STATE_INTERMEDIATE if state
		// transition is not complete or an error value if the method failed.
		HRESULT GetState(
					/*in*/ DWORD dwMilliSecsTimeout,
					/*out*/ FILTER_STATE *State);


		// tell the filter the reference clock to which it should synchronize
		// activity. This is most important to rendering filters and may not
		// be of any interest to other filters.
		HRESULT SetSyncSource(
			/*in*/ IReferenceClock pClock);

		// get the reference clock currently in use (it may be NULL)
		HRESULT GetSyncSource(
			/*out*/ IReferenceClock * pClock);
	}


	struct AM_MEDIA_TYPE {
		GUID     majortype;
		GUID     subtype;
		BOOL     bFixedSizeSamples;
		BOOL     bTemporalCompression;
		ULONG    lSampleSize;
		GUID     formattype;
		IUnknown pUnk;
		ULONG    cbFormat;
		/*[size_is(cbFormat)]*/ BYTE * pbFormat;
	}

	/*[
	object,
	uuid(89c31040-846b-11ce-97d3-00aa0055595a),
	pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("89c31040-846b-11ce-97d3-00aa0055595a"));
	interface IEnumMediaTypes : IUnknown {

		// to call this member function pass in the address of a pointer to a
		// media type. The interface will allocate the necessary AM_MEDIA_TYPE
		// structures and initialise them with the variable format block

		HRESULT Next(
			/*[in]*/ ULONG cMediaTypes,             // place this many types...
			/*[out, size_is(cMediaTypes)]*/
				 AM_MEDIA_TYPE ** ppMediaTypes, // ...in this array
			/*[out]*/ ULONG * pcFetched             // actual count passed
		);

		HRESULT Skip(
			/*[in]*/ ULONG cMediaTypes);

		HRESULT Reset();

		HRESULT Clone(
			/*[out]*/ IEnumMediaTypes *ppEnum
		);
	}

	/*[
	object,
	uuid(56a86891-0ad4-11ce-b03a-0020af0ba770),
	pointer_default(unique)
	]*/
	// get information about the pin itself
	struct PIN_INFO {
		IBaseFilter pFilter;   // the filter this pin is on
		PIN_DIRECTION dir;  // am I an input or output pin?
		WCHAR achName[MAX_PIN_NAME];    // the name of this pin within this filter
	}
	mixin(MIDL_INTERFACE("56a86891-0ad4-11ce-b03a-0020af0ba770"));
	interface IPin : IUnknown {

		// initiate a connection to another pin. calls ReceiveConnection on the
		// other pin. Verifies that the connection is possible and may reject
		// it.
		// The mediatype parameter is optional. If it is not null, the pin must
		// connect using that media type if possible. The subtype and/or format
		// type can be GUID_NULL, meaning that the pin can fill them in as desired.
		// This allows an application to partially specify the media type to be
		// used for the connection, insisting on eg YUV 422 but leaving details
		// (such as the image size) to be negotiated between the pins.
		HRESULT Connect(
			/*in*/ IPin pReceivePin,        // connect yourself to this pin
			/*in*/ const AM_MEDIA_TYPE * pmt  // (optional) connect using this type
		);

		// called by a connecting pin to make a connection
		HRESULT ReceiveConnection(
			/*in*/ IPin pConnector,
			/*in*/ const AM_MEDIA_TYPE *pmt   // this is the media type we will exchange
		);

		// break a connection - no params since there is only one connection
		// possible on this pin
		HRESULT Disconnect();

		// Find the pin this pin is connected to (if any)
		// The pointer returned is AddRef()d
		// Fails if the pin is not connected
		HRESULT ConnectedTo(
			/*out*/ IPin* pPin
		);

		// Return the media type of a connection if the pin is connected
		HRESULT ConnectionMediaType(
			/*out*/ AM_MEDIA_TYPE *pmt
		);


		HRESULT QueryPinInfo(
			/*out*/ PIN_INFO * pInfo
		);

		// We often want to know the direction.  Rather than use the
		// relatively expensive QueryPinInfo, use this
		HRESULT QueryDirection(
			/*out*/ PIN_DIRECTION *pPinDir
		);

		// Get an identifier for the pin (allows connections to be saved).
		// The storage will be allocated by the filter using CoTaskMemAlloc
		// The caller should free it using CoTaskMemFree
		HRESULT QueryId(
			/*out*/ LPWSTR * Id
		);

		// will the pin accept the format type, S_OK yes, S_FALSE no
		HRESULT QueryAccept(
			/*in*/ const AM_MEDIA_TYPE *pmt
		);

		// return an enumerator for this pin's preferred media types
		HRESULT EnumMediaTypes(
			/*out*/ IEnumMediaTypes *ppEnum
		);

		// return an array of IPin* - the pins that this pin internally connects to
		// All pins put in the array must be AddReffed (but no others)
		// Errors: "Can't say" - FAIL; not enough slots - return S_FALSE
		// Default: return E_NOTIMPL
		// The filter graph will interpret E_NOTIMPL as any input pin connects to
		// all visible output pins and vise versa.
		// apPin can be NULL if nPin==0 (not otherwise).
		HRESULT QueryInternalConnections(
			/*out*/ IPin *apPin,     // array of IPin*
			/*[in, out]*/ ULONG *nPin   // on input, the number of slots
									// on output  the number of pins
		);

		// notify the pin that no more data is expected until a new run
		// command is issued. End of stream should be queued and delivered after
		// all queued data is delivered. Pass through if there is no queued data.
		// Flush should flush any queued EOS.
		// returns S_OK unless there is some error.
		// input pins only: output pins will normally return E_UNEXPECTED.
		HRESULT EndOfStream();

		// Flush

		// Enter flush state: do the following steps (in order)
		// -- prevent any more Receives succeeding (set a flushing flag)
		// -- discard any queued data
		// -- free anyone blocked on Receive in your filter
		// -- pass BeginFlush to any downstream pins
		HRESULT BeginFlush();

		// End flush state: do the following steps in order
		// -- ensure no more data will be pushed by your filter
		//    (sync with thread if you have one, stop it pushing and
		//     discard any queued data)
		// -- re-enable Receive (clear internal flushing flag)
		// -- pass EndFlush to any downstream pins
		HRESULT EndFlush();

		// informational: all data arriving after this call is part of a segment
		// from StartTime to StopTime, played at rate. This allows filters that
		// process buffers containing more than one sample to clip the rendering
		// to within the start and stop times.
		//
		// A source pin will call a destination pin on this method after completing
		// delivery of any previous data, and before any Receive calls for the
		// new data
		HRESULT NewSegment(
					/*in*/ REFERENCE_TIME tStart,
					/*in*/ REFERENCE_TIME tStop,
					/*in*/ double dRate);
	}

	/*[
	object,
	uuid(56a86892-0ad4-11ce-b03a-0020af0ba770),
	pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("56a86892-0ad4-11ce-b03a-0020af0ba770"));
	interface IEnumPins : IUnknown {

		HRESULT Next(
			/*in*/ ULONG cPins,                       // place this many pins...
			/*[out, size_is(cPins)]*/ IPin * ppPins,   // ...in this array
			/*out*/ ULONG * pcFetched                 // actual count passed
		);

		HRESULT Skip(
			/*in*/ ULONG cPins);

		HRESULT Reset();

		HRESULT Clone(
			/*out*/ IEnumPins *ppEnum
		);
	}

	/*[
	object,
	uuid(56a86893-0ad4-11ce-b03a-0020af0ba770),
	pointer_default(unique)
	]*/
	interface IEnumFilters : IUnknown {

		HRESULT Next
			( /*[in]*/  ULONG cFilters,           // place this many filters...
			  /*[out]*/ IBaseFilter * ppFilter,  // ...in this array of IBaseFilter*
			  /*[out]*/ ULONG * pcFetched         // actual count passed returned here
			);


		HRESULT Skip
			( /*[in]*/ ULONG cFilters
			);


		HRESULT Reset();


		HRESULT Clone
			( /*[out]*/ IEnumFilters *ppEnum
			);
	}

	/*[
	object,
	uuid(56a8689f-0ad4-11ce-b03a-0020af0ba770),
	pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("56a8689f-0ad4-11ce-b03a-0020af0ba770"));
	interface IFilterGraph : IUnknown {

		//==========================================================================
		// Low level filter functions
		//==========================================================================

			// Add a filter to the graph and name it with *pName.
			// If the name is not unique, The request will fail.
			// The Filter graph will call the JoinFilterGraph
			// member function of the filter to inform it.
			// This must be called before attempting Connect, ConnectDirect or Render
			// for pins of the filter.

			HRESULT AddFilter
				( /*in*/ IBaseFilter pFilter,
				  /*[in, string]*/ LPCWSTR pName
				);


			// Remove a filter from the graph. The filter graph implementation
			// will inform the filter that it is being removed.

			HRESULT RemoveFilter
				( /*in*/ IBaseFilter pFilter
				);


			// Set *ppEnum to be an enumerator for all filters in the graph.

			HRESULT EnumFilters
				( /*out*/ IEnumFilters *ppEnum
				);


			// Set *ppFilter to be the filter which was added with the name *pName
			// Will fail and set *ppFilter to NULL if the name is not in this graph.

			HRESULT FindFilterByName
				( /*[in, string]*/ LPCWSTR pName,
				  /*out*/ IBaseFilter* ppFilter
				);

		//==========================================================================
		// Low level connection functions
		//==========================================================================

			// Connect these two pins directly (i.e. without intervening filters)
			// the media type is optional, and may be partially specified (that is
			// the subtype and/or format type may be GUID_NULL). See IPin::Connect
			// for details of the media type parameter.
			HRESULT ConnectDirect
				( /*in*/ IPin ppinOut,              // the output pin
				  /*in*/ IPin ppinIn,               // the input pin
				  /*[in, unique]*/ const AM_MEDIA_TYPE* pmt     // optional mediatype
				);

			// Break the connection that this pin has and reconnect it to the
			// same other pin.

			HRESULT Reconnect
				( /*in*/ IPin ppin        // the pin to disconnect and reconnect
				);



			// Disconnect this pin, if connected.  Successful no-op if not connected.

			HRESULT Disconnect
				( /*in*/ IPin ppin
				);

		//==========================================================================
		// intelligent connectivity - now in IGraphBuilder, axextend.idl
		//==========================================================================

		//==========================================================================
		// Whole graph functions
		//==========================================================================

		// Once a graph is built, it can behave as a (composite) filter.
		// To control this filter, QueryInterface for IMediaFilter.

		// The filtergraph will by default ensure that the graph has a sync source
		// when it is made to Run.  SetSyncSource(NULL) will prevent that and allow
		// all the filters to run unsynchronised until further notice.
		// SetDefaultSyncSource will set the default sync source (the same as would
		// have been set by default on the first call to Run).
		HRESULT SetDefaultSyncSource();

	}

	/*[
	object,
	uuid(56a86895-0ad4-11ce-b03a-0020af0ba770),
	pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("56a86895-0ad4-11ce-b03a-0020af0ba770"));
	interface IBaseFilter : IMediaFilter {

		// enumerate all the pins available on this filter
		// allows enumeration of all pins only.
		//
		HRESULT EnumPins(
			/*out*/ IEnumPins * ppEnum     // enum interface returned here
		);

		// Convert the external identifier of a pin to an IPin *
		// This pin id is quite different from the pin Name in CreatePin.
		// In CreatePin the Name is invented by the caller.  In FindPin the Id
		// must have come from a previous call to IPin::QueryId.  Whether or not
		// this operation would cause a pin to be created depends on the filter
		// design, but if called twice with the same id it should certainly
		// return the same pin both times.
		HRESULT FindPin(
			/*[in, string]*/ LPCWSTR Id,
			/*out*/ IPin * ppPin
		);

		HRESULT QueryFilterInfo(
			/*out*/ FILTER_INFO * pInfo
		);

		// notify a filter that it has joined a filter graph. It is permitted to
		// refuse. The filter should addref and store this interface for later use
		// since it may need to notify events to this interface. A null pointer indicates
		// that the filter is no longer part of a graph.
		HRESULT JoinFilterGraph(
			/*in*/ IFilterGraph pGraph,
			/*[in, string]*/ LPCWSTR pName
		);

		// return a Vendor information string. Optional - may return E_NOTIMPL.
		// memory returned should be freed using CoTaskMemFree
		HRESULT QueryVendorInfo(
			/*[out, string]*/ LPWSTR* pVendorInfo
		);
	}
	// find out information about this filter
	struct FILTER_INFO {
		WCHAR achName[MAX_FILTER_NAME]; // maybe null if not part of graph
		IFilterGraph pGraph;                   // null if not part of graph
	}

	/*[
			local,
			object,
			uuid(56a8689a-0ad4-11ce-b03a-0020af0ba770),
			pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("56a8689a-0ad4-11ce-b03a-0020af0ba770"));
	interface IMediaSample : IUnknown {

		// get me a read/write pointer to this buffer's memory. I will actually
		// want to use sizeUsed bytes.
		HRESULT GetPointer(/*out*/ BYTE ** ppBuffer);

		// return the size in bytes of the buffer data area
		LONG GetSize();

		// get the stream time at which this sample should start and finish.
		HRESULT GetTime(
			/*out*/ REFERENCE_TIME * pTimeStart,  // put time here
			/*out*/ REFERENCE_TIME * pTimeEnd
		);

		// Set the stream time at which this sample should start and finish.
		// pTimeStart==pTimeEnd==NULL will invalidate the time stamps in
		// this sample
		HRESULT SetTime(
			/*in*/ REFERENCE_TIME * pTimeStart,   // put time here
			/*in*/ REFERENCE_TIME * pTimeEnd
		);

		// sync-point property. If true, then the beginning of this
		// sample is a sync-point. (note that if AM_MEDIA_TYPE.bTemporalCompression
		// is false then all samples are sync points). A filter can start
		// a stream at any sync point.  S_FALSE if not sync-point, S_OK if true.

		HRESULT IsSyncPoint();
		HRESULT SetSyncPoint(BOOL bIsSyncPoint);

		// preroll property.  If true, this sample is for preroll only and
		// shouldn't be displayed.
		HRESULT IsPreroll();
		HRESULT SetPreroll(BOOL bIsPreroll);

		LONG GetActualDataLength();
		HRESULT SetActualDataLength(LONG);

		// these allow for limited format changes in band - if no format change
		// has been made when you receive a sample GetMediaType will return S_FALSE

		HRESULT GetMediaType(AM_MEDIA_TYPE **ppMediaType);
		HRESULT SetMediaType(AM_MEDIA_TYPE *pMediaType);

		// returns S_OK if there is a discontinuity in the data (this frame is
		// not a continuation of the previous stream of data
		// - there has been a seek or some dropped samples).
		HRESULT IsDiscontinuity();
		// set the discontinuity property - TRUE if this sample is not a
		// continuation, but a new sample after a seek or a dropped sample.
		HRESULT SetDiscontinuity(BOOL bDiscontinuity);

		// get the media times for this sample
		HRESULT GetMediaTime(
			/*out*/ LONGLONG * pTimeStart,
			/*out*/ LONGLONG * pTimeEnd
		);

		// Set the media times for this sample
		// pTimeStart==pTimeEnd==NULL will invalidate the media time stamps in
		// this sample
		HRESULT SetMediaTime(
			/*in*/ LONGLONG * pTimeStart,
			/*in*/ LONGLONG * pTimeEnd
		);
	}

	/*[
		object,
		uuid(56a868a9-0ad4-11ce-b03a-0020af0ba770),
		pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("56a868a9-0ad4-11ce-b03a-0020af0ba770"));
	interface IGraphBuilder : IFilterGraph {
		// Connect these two pins directly or indirectly, using transform filters
		// if necessary.

		HRESULT Connect
			( /*in*/ IPin ppinOut,    // the output pin
			  /*in*/ IPin ppinIn      // the input pin
			);


		// Connect this output pin directly or indirectly, using transform filters
		// if necessary to something that will render it.

		HRESULT Render
			( /*in*/ IPin ppinOut     // the output pin
			);


		// Build a filter graph that will render this file using this play list.
		// If lpwstrPlayList is NULL then it will use the default play list
		// which will typically render the whole file.

		HRESULT RenderFile
			( /*in*/ LPCWSTR lpcwstrFile,
			  /*[in, unique]*/ LPCWSTR lpcwstrPlayList
			);


		// Add to the filter graph a source filter for this file.  This would
		// be the same source filter that would be added by calling Render.
		// This call gives you more control over building
		// the rest of the graph, e.g. AddFilter(<a renderer of your choice>)
		// and then Connect the two.
		// The IBaseFilter* interface exposed by the source filter is returned
		// in ppFilter, addrefed already for you
		// The filter will be known by the name lpcwstrFIlterName
		// nn this filter graph,
		HRESULT AddSourceFilter
			( /*in*/      LPCWSTR lpcwstrFileName,
			  /*[in, unique]*/      LPCWSTR lpcwstrFilterName,
			  /*out*/     IBaseFilter* ppFilter
			);


		// If this call is made then trace information will be written to the
		// file showing the actions taken in attempting to perform an operation.
		HRESULT SetLogFile
			( /*in*/      DWORD_PTR hFile  // open file handle e.g. from CreateFile
			);


		// Request that the graph builder should return as soon as possible from
		// its current task.
		// Note that it is possible fot the following to occur in the following
		// sequence:
		//     Operation begins; Abort is requested; Operation completes normally.
		// This would be normal whenever the quickest way to finish an operation
		// was to simply continue to the end.
		HRESULT Abort();

		// Return S_OK if the curent operation is to continue,
		// return S_FALSE if the current operation is to be aborted.
		// This method can be called as a callback from a filter which is doing
		// some operation at the request of the graph.
		HRESULT ShouldOperationContinue();

	}


	/*[
			object,
			uuid(a2104830-7c70-11cf-8bce-00aa00a3f1a6),
			pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("a2104830-7c70-11cf-8bce-00aa00a3f1a6"));
	interface IFileSinkFilter : IUnknown {

		// Output to this file. default is to open the existing file
		HRESULT SetFileName(
			/*in*/ LPCOLESTR pszFileName,     // Pointer to absolute path of output file
			/*[in, unique]*/ const AM_MEDIA_TYPE *pmt   // Media type of file - can be NULL
		);
		// Get the current file name
		HRESULT GetCurFile(
			/*out*/ LPOLESTR *ppszFileName,   // Pointer to the path for the current file
			/*out*/ AM_MEDIA_TYPE *pmt        // Pointer to the media type
		);
	}

	/*[
		object,
		uuid(670d1d20-a068-11d0-b3f0-00aa003761c5),
		pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("670d1d20-a068-11d0-b3f0-00aa003761c5"));
	interface IAMCopyCaptureFileProgress : IUnknown {

		// If you support this interface somewhere, this function will be called
		// periodically while ICaptureGraphBuilder::CopyCaptureFile is executing
		// to let you know the progress
		//
		// Return S_OK from this function to continue.  Return S_FALSE to abort the
		// copy
		HRESULT Progress(
		/*in*/ int iProgress);        // a number between 0 and 100 (%)
	}

	/*[
		object,
		uuid(bf87b6e0-8c27-11d0-b3f0-00aa003761c5),
		pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("bf87b6e0-8c27-11d0-b3f0-00aa003761c5"));
	interface ICaptureGraphBuilder : IUnknown {

		// Use this filtergraph
		HRESULT SetFiltergraph(
		/*in*/ IGraphBuilder *pfg);

		// what filtergraph are you using?
		// *ppfg->Release() when you're done with it
		HRESULT GetFiltergraph(
		/*out*/ IGraphBuilder **ppfg);

		// creates a rendering section in the filtergraph consisting of a MUX
		// of some filetype, and a file writer (and connects them together)
		// *ppf->Release() when you're done with it
		// *ppSink->Release() when you're done with it
		HRESULT SetOutputFileName(
		/*in*/ const GUID *pType, // type of file to write, eg. MEDIASUBTYPE_Avi
		/*in*/ LPCOLESTR lpstrFile,   // filename given to file writer
		/*out*/ IBaseFilter **ppf,    // returns pointer to the MUX
			/*out*/ IFileSinkFilter **ppSink);// queried from file writer

		// Looks for an interface on the filter and on the output pin of the given
		// category.  (Categories: CAPTURE/PREVIEW/VIDEOPORT/VBI etc. or
		// NULL for "don't care".
		// It will also look upstream and downstream of
		// the pin for the interface, to find interfaces on renderers, MUXES, TV
		// Tuners, etc.
		// Call *ppint->Release() when you're done with it
		/*[local]*/ HRESULT FindInterface(
		/*[in, unique]*/ const GUID *pCategory, // can be NULL for all pins
		/*in*/ IBaseFilter *pf,
		/*in*/ REFIID riid,
		/*out*/ void **ppint);
		/+ [call_as(FindInterface)] HRESULT RemoteFindInterface(
		/*[in, unique]*/ const GUID *pCategory, // can be NULL for all pins
		/*in*/ IBaseFilter *pf,
		/*in*/ REFIID riid,
		/*out*/ IUnknown **ppint); +/

		// Connects the pin of the given category of the source filter to the
		// rendering filter, optionally through another filter (compressor?)
		// For a non-NULL category, it will instantiate and connect additional
		// required filters upstream too, like TV Tuners and Crossbars.
		// If there is only one output pin on the source, use a NULL
		// category.  You can also have pSource be a pin
		HRESULT RenderStream(
		/*in*/ const GUID *pCategory, // can be NULL if only one output pin
		/*in*/ IUnknown *pSource,     // filter or pin
		/*in*/ IBaseFilter *pfCompressor,
		/*in*/ IBaseFilter *pfRenderer);  // can be NULL

		// Sends IAMStreamControl messages to the pin of the desired category, eg.
		// "capture" or "preview"
		// REFERENCE_TIME=NULL means NOW
		// REFERENCE_TIME=MAX_TIME means never, or cancel previous request
		// NULL controls all capture filters in the graph - you will get one
		//     notification for each filter with a pin of that category found
		// returns S_FALSE if stop will be signalled before last sample is
		//     rendered.
		// return a FAILURE code if the filter does not support IAMStreamControl
		HRESULT ControlStream(
		/*in*/ const GUID *pCategory,
		/*in*/ IBaseFilter *pFilter,
		/*in*/ REFERENCE_TIME *pstart,
		/*in*/ REFERENCE_TIME *pstop,
		/*in*/ WORD wStartCookie,     // high word reserved
		/*in*/ WORD wStopCookie);     // high word reserved

		// creates a pre-allocated file of a given size in bytes
		HRESULT AllocCapFile(
		/*in*/ LPCOLESTR lpstr,
		/*in*/ DWORDLONG dwlSize);

		// Copies the valid file data out of the old, possibly huge old capture
		//   file into a shorter new file.
		// Return S_FALSE from your progress function to abort capture, S_OK to
		//   continue
		HRESULT CopyCaptureFile(
		/*in*/ LPOLESTR lpwstrOld,
		/*in*/ LPOLESTR lpwstrNew,
		/*in*/ int fAllowEscAbort,    // pressing ESC will abort?
		/*in*/ IAMCopyCaptureFileProgress *pCallback);    // implement this to
								// get progress
	}

	/*[
		object,
		uuid(93E5A4E0-2D50-11d2-ABFA-00A0C9C6E38D),
		pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("93E5A4E0-2D50-11d2-ABFA-00A0C9C6E38D"));
	interface ICaptureGraphBuilder2 : IUnknown {

		// Use this filtergraph
		HRESULT SetFiltergraph(
		/*in*/ IGraphBuilder pfg);

		// what filtergraph are you using?
		// *ppfg->Release() when you're done with it
		HRESULT GetFiltergraph(
		/*out*/ IGraphBuilder *ppfg);

		// creates a rendering section in the filtergraph consisting of a MUX
		// of some filetype, and a file writer (and connects them together)
		// *ppf->Release() when you're done with it
		// *ppSink->Release() when you're done with it
		HRESULT SetOutputFileName(
		/*in*/ const GUID *pType,     // GUID of MUX filter to use
		/*in*/ LPCOLESTR lpstrFile,   // filename given to file writer
		/*out*/ IBaseFilter *ppf,    // returns pointer to the MUX
			/*out*/ IFileSinkFilter *ppSink);// queried from file writer

		// Looks for an interface on the filter and on the output pin of the given
		// category and type.  (Categories: CAPTURE/PREVIEW/VIDEOPORT/VBI etc. or
		// NULL for "don't care".  Type:  MAJORTYPE_Video/Audio etc or NULL)
		// !!! Will some filters have >1 capture pin?  ie RGB and MPEG?
		// It will also look upstream and downstream of
		// the pin for the interface, to find interfaces on renderers, MUXES, TV
		// Tuners, etc.
		// Call *ppint->Release() when you're done with it
		/*[local]*/ HRESULT FindInterface(
		/*in*/ const GUID *pCategory, // can be NULL for all pins
		/*in*/ const GUID *pType,     // Audio/Video/??? or NULL (don't care)
		/*in*/ IBaseFilter pf,
		/*in*/ REFIID riid,
		/*out*/ void *ppint);
		/+[call_as(FindInterface)] HRESULT RemoteFindInterface(
		/*in*/ const GUID *pCategory, // can be NULL for all pins
		/*in*/ const GUID *pType,     // Audio/Video/??? or NULL (don't care)
		/*in*/ IBaseFilter pf,
		/*in*/ REFIID riid,
		/*out*/ IUnknown *ppint);+/

		// Connects the pin of the given category and type of the source filter to
		// the rendering filter, optionally through another filter (compressor?)
		// (Type is a Majortype, like Video or Audio)
		// For a non-NULL category, it will instantiate and connect additional
		// required filters upstream too, like TV Tuners and Crossbars.
		// If there is only one output pin on the source, use a NULL category
		// and type.  You can also have pSource be a pin
		HRESULT RenderStream(
		/*in*/ const GUID *pCategory, // can be NULL if only one output pin
		/*in*/ const GUID *pType,     // Major type (Video/Audio/etc)
		/*in*/ IUnknown pSource,     // filter or pin
		/*in*/ IBaseFilter pfCompressor,
		/*in*/ IBaseFilter pfRenderer);  // can be NULL

		// Sends IAMStreamControl messages to the pin of the desired category,
		// (eg. "capture" or "preview") and of the desired type (eg. VIDEO or AUDIO)
		// A category MUST be given.  If a filter is given, a type must be too.
		// REFERENCE_TIME=NULL means NOW
		// REFERENCE_TIME=MAX_TIME means never, or cancel previous request
		// NULL controls all capture filters in the graph - you will get one
		//     notification for each filter with a pin of that category found
		// returns S_FALSE if stop will be signalled before last sample is
		//     rendered.
		// return a FAILURE code if the filter does not support IAMStreamControl
		HRESULT ControlStream(
		/*in*/ const GUID *pCategory,
		/*in*/ const GUID *pType,     // Major type (Video/Audio/etc)
		/*in*/ IBaseFilter pFilter,
		/*in*/ REFERENCE_TIME *pstart,
		/*in*/ REFERENCE_TIME *pstop,
		/*in*/ WORD wStartCookie,     // high word reserved
		/*in*/ WORD wStopCookie);     // high word reserved

		// creates a pre-allocated file of a given size in bytes
		HRESULT AllocCapFile(
		/*in*/ LPCOLESTR lpstr,
		/*in*/ DWORDLONG dwlSize);

		// Copies the valid file data out of the old, possibly huge old capture
		//   file into a shorter new file.
		// Return S_FALSE from your progress function to abort capture, S_OK to
		//   continue
		HRESULT CopyCaptureFile(
		/*in*/ LPOLESTR lpwstrOld,
		/*in*/ LPOLESTR lpwstrNew,
		/*in*/ int fAllowEscAbort,    // pressing ESC will abort?
		/*in*/ IAMCopyCaptureFileProgress pCallback);    // implement this to
								// get progress
		// Helper fn to find a certain pin on a filter.
		HRESULT FindPin(
		/*in*/ IUnknown pSource,
		/*in*/ PIN_DIRECTION pindir,  // input or output?
		/*in*/ const GUID *pCategory, // what category? (or NULL)
		/*in*/ const GUID *pType,     // what Major type (or NULL)
		/*in*/ BOOL fUnconnected,     // must it be unconnected?
		/*in*/ int num,           // which pin matching this? (0 based)
		/*out*/ IPin *ppPin);
	}


	/*[
			object,
			uuid(36b73880-c2c8-11cf-8b46-00805f6cef60),
			pointer_default(unique)
	]*/
	mixin(MIDL_INTERFACE("36b73880-c2c8-11cf-8b46-00805f6cef60"));
	interface IMediaSeeking : IUnknown {

		// Returns the capability flags
		HRESULT GetCapabilities( /*out*/ DWORD * pCapabilities );

		// And's the capabilities flag with the capabilities requested.
		// Returns S_OK if all are present, S_FALSE if some are present, E_FAIL if none.
		// *pCababilities is always updated with the result of the 'and'ing and can be
		// checked in the case of an S_FALSE return code.
		HRESULT CheckCapabilities( /*[in,out]*/ DWORD * pCapabilities );

		// returns S_OK if mode is supported, S_FALSE otherwise
		HRESULT IsFormatSupported(/*in*/ const GUID * pFormat);
		HRESULT QueryPreferredFormat(/*out*/ GUID * pFormat);

		HRESULT GetTimeFormat(/*out*/ GUID *pFormat);
		// Returns S_OK if *pFormat is the current time format, otherwise S_FALSE
		// This may be used instead of the above and will save the copying of the GUID
		HRESULT IsUsingTimeFormat(/*in*/ const GUID * pFormat);

		// (may return VFE_E_WRONG_STATE if graph is stopped)
		HRESULT SetTimeFormat(/*in*/ const GUID * pFormat);

		// return current properties
		HRESULT GetDuration(/*out*/ LONGLONG *pDuration);
		HRESULT GetStopPosition(/*out*/ LONGLONG *pStop);
		HRESULT GetCurrentPosition(/*out*/ LONGLONG *pCurrent);

		// Convert time from one format to another.
		// We must be able to convert between all of the formats that we say we support.
		// (However, we can use intermediate formats (e.g. MEDIA_TIME).)
		// If a pointer to a format is null, it implies the currently selected format.
		HRESULT ConvertTimeFormat(/*out*/ LONGLONG * pTarget, /*in*/ const GUID * pTargetFormat,
								  /*in*/  LONGLONG    Source, /*in*/ const GUID * pSourceFormat );


		// Set current and end positions in one operation
		// Either pointer may be null, implying no change
		HRESULT SetPositions( /*[in,out]*/ LONGLONG * pCurrent, /*in*/ DWORD dwCurrentFlags
				, /*[in,out]*/ LONGLONG * pStop, /*in*/ DWORD dwStopFlags );

		// Get CurrentPosition & StopTime
		// Either pointer may be null, implying not interested
		HRESULT GetPositions( /*out*/ LONGLONG * pCurrent,
							  /*out*/ LONGLONG * pStop );

		// Get earliest / latest times to which we can currently seek "efficiently".
		// This method is intended to help with graphs where the source filter has
		// a very high latency.  Seeking within the returned limits should just
		// result in a re-pushing of already cached data.  Seeking beyond these
		// limits may result in extended delays while the data is fetched (e.g.
		// across a slow network).
		// (NULL pointer is OK, means caller isn't interested.)
		HRESULT GetAvailable( /*out*/ LONGLONG * pEarliest, /*out*/ LONGLONG * pLatest );

		// Rate stuff
		HRESULT SetRate(/*in*/  double dRate);
		HRESULT GetRate(/*out*/ double * pdRate);

		// Preroll
		HRESULT GetPreroll(/*out*/ LONGLONG * pllPreroll);
	}

	alias int OAFilterState;

    // core control providing state control
    /*[
        uuid(56a868b1-0ad4-11ce-b03a-0020af0ba770),
        helpstring("IMediaControl interface"),
        odl,
        oleautomation,
        dual
    ]*/
	mixin(MIDL_INTERFACE("56a868b4-0ad4-11ce-b03a-0020af0ba770"));
    interface IMediaControl : IDispatch
    {
        // methods
        HRESULT Run();
        HRESULT Pause();
        HRESULT Stop();

        //returns the state. same semantics as IMediaFilter::GetState

        HRESULT GetState(
                    /*in*/ LONG msTimeout,
                    /*out*/ OAFilterState* pfs);

        // adds and connects filters needed to play the specified file
        // (same as IFilterGraph::RenderFile)
        HRESULT RenderFile(
                    /*in*/ BSTR strFilename);

        // adds to the graph the source filter that can read this file,
        // and returns an IFilterInfo object for it (actually returns
        // an IDispatch for the IFilterInfo object).
        HRESULT AddSourceFilter(
                    /*in*/ BSTR strFilename,
                    /*out*/ IDispatch*ppUnk);

        // get a collection of IFilterInfo objects representing the
        // filters in the graph (returns IDispatch for an object
        // that supports IAMCollection
        /*propget*/
        HRESULT get_FilterCollection(
                        /*out, retval*/ IDispatch* ppUnk);

        // get a collection of IRegFilter objects representing the
        // filters available in the registry
        /*propget*/
        HRESULT get_RegFilterCollection(
                        /*out, retval*/ IDispatch* ppUnk);

        HRESULT StopWhenReady();
    }

    /*[
        uuid(56a868b4-0ad4-11ce-b03a-0020af0ba770),
        helpstring("IVideoWindow interface"),
        odl,
        oleautomation,
        dual
    ]*/
	mixin(MIDL_INTERFACE("56a868b4-0ad4-11ce-b03a-0020af0ba770"));
    interface IVideoWindow : IDispatch
    {
        // properties

        // set and get the window title caption

        /*propput*/
        HRESULT put_Caption(/*in*/ BSTR strCaption);
        /*propget*/
        HRESULT get_Caption(/*out, retval*/ BSTR *strCaption);

        // change the window styles (as per Win32)

        /*propput*/
        HRESULT put_WindowStyle(/*in*/ LONG WindowStyle);
        /*propget*/
        HRESULT get_WindowStyle(/*out, retval*/ LONG *WindowStyle);

        // change the extended window styles (as per Win32)

        /*propput*/
        HRESULT put_WindowStyleEx(/*in*/ LONG WindowStyleEx);
        /*propget*/
        HRESULT get_WindowStyleEx(/*out, retval*/ LONG *WindowStyleEx);

        /*propput*/
        HRESULT put_AutoShow(/*in*/ LONG AutoShow);
        /*propget*/
        HRESULT get_AutoShow(/*out, retval*/ LONG *AutoShow);

        // change the window state (as per Win32)

        /*propput*/
        HRESULT put_WindowState(/*in*/ LONG WindowState);
        /*propget*/
        HRESULT get_WindowState(/*out, retval*/ LONG *WindowState);

        // realise the palette in the background

        /*propput*/
        HRESULT put_BackgroundPalette(/*in*/ LONG BackgroundPalette);
        /*propget*/
        HRESULT get_BackgroundPalette(/*out, retval*/ LONG *pBackgroundPalette);

        // affect the visibility of the window

        /*propput*/
        HRESULT put_Visible(/*in*/ LONG Visible);
        /*propget*/
        HRESULT get_Visible(/*out, retval*/ LONG *pVisible);

        // change the desktop position of the video window

        /*propput*/
        HRESULT put_Left(/*in*/ LONG Left);
        /*propget*/
        HRESULT get_Left(/*out, retval*/ LONG *pLeft);

        /*propput*/
        HRESULT put_Width(/*in*/ LONG Width);
        /*propget*/
        HRESULT get_Width(/*out, retval*/ LONG *pWidth);

        /*propput*/
        HRESULT put_Top(/*in*/ LONG Top);
        /*propget*/
        HRESULT get_Top(/*out, retval*/ LONG *pTop);

        /*propput*/
        HRESULT put_Height(/*in*/ LONG Height);
        /*propget*/
        HRESULT get_Height(/*out, retval*/ LONG *pHeight);

        // change the owning window of the video

        /*propput*/
        HRESULT put_Owner(/*in*/ OAHWND Owner);
        /*propget*/
        HRESULT get_Owner(/*out, retval*/ OAHWND *Owner);

        // change the window to receive posted messages

        /*propput*/
        HRESULT put_MessageDrain(/*in*/ OAHWND Drain);
        /*propget*/
        HRESULT get_MessageDrain(/*out, retval*/ OAHWND *Drain);

        /*propget*/
        HRESULT get_BorderColor(/*out, retval*/ LONG *Color);

        /*propput*/
        HRESULT put_BorderColor(/*in*/ LONG Color);

        /*propget*/
        HRESULT get_FullScreenMode(/*out, retval*/ LONG *FullScreenMode);

        /*propput*/
        HRESULT put_FullScreenMode(/*in*/ LONG FullScreenMode);

        // methods

        // ask the renderer to grab it's window the foreground
        // and optionally also give the window the input focus
        HRESULT SetWindowForeground(/*in*/ LONG Focus);

        // owners should pass WM_PALETTECHANGED and WM_SYSCOLORCHANGE
        // messages on the filter graph so they can be distributed
        // otherwise child renderers never see these messages go by

        HRESULT NotifyOwnerMessage(/*in*/ OAHWND hwnd,
                                   /*in*/ LONG uMsg,
                                   /*in*/ LONG_PTR wParam,
                                   /*in*/ LONG_PTR lParam
                                   );

        // get and set the window position on the desktop

        HRESULT SetWindowPosition(/*in*/ LONG Left,
                                  /*in*/ LONG Top,
                                  /*in*/ LONG Width,
                                  /*in*/ LONG Height);

        HRESULT GetWindowPosition(/*out*/ LONG *pLeft,
                                  /*out*/ LONG *pTop,
                                  /*out*/ LONG *pWidth,
                                  /*out*/ LONG *pHeight);

        // get the ideal sizes for the video image playback (client) area

        HRESULT GetMinIdealImageSize(/*out*/ LONG *pWidth,/*out*/ LONG *pHeight);
        HRESULT GetMaxIdealImageSize(/*out*/ LONG *pWidth,/*out*/ LONG *pHeight);

        // get the restored window size when we're maximised or iconic

        HRESULT GetRestorePosition(/*out*/ LONG *pLeft,
                                   /*out*/ LONG *pTop,
                                   /*out*/ LONG *pWidth,
                                   /*out*/ LONG *pHeight);

		// show and hide cursors useful when fullscreen
		HRESULT HideCursor(/*in*/ LONG HideCursor);
        HRESULT IsCursorHidden(/*out*/ LONG *CursorHidden);
    }

	mixin(MIDL_INTERFACE("0579154A-2B53-4994-B0D0-E773148EFF85"));
	interface ISampleGrabberCB : IUnknown
	{
		HRESULT SampleCB( double SampleTime, IMediaSample pSample );
		HRESULT BufferCB( double SampleTime, BYTE * pBuffer, LONG BufferLen );
	}

	mixin(MIDL_INTERFACE("6B652FFF-11FE-4fce-92AD-0266B5D7C78F"));
    interface ISampleGrabber : IUnknown
    {
        HRESULT /*STDMETHODCALLTYPE*/ SetOneShot( BOOL OneShot );
        HRESULT /*STDMETHODCALLTYPE*/ SetMediaType( const AM_MEDIA_TYPE *pType );
        HRESULT /*STDMETHODCALLTYPE*/ GetConnectedMediaType( AM_MEDIA_TYPE *pType );
        HRESULT /*STDMETHODCALLTYPE*/ SetBufferSamples( BOOL BufferThem );
        HRESULT /*STDMETHODCALLTYPE*/ GetCurrentBuffer( /*[out, in]*/ LONG *pBufferSize, /*out*/ LONG *pBuffer );
        HRESULT /*STDMETHODCALLTYPE*/ GetCurrentSample( /*[retval, out]*/ IMediaSample *ppSample );
        HRESULT /*STDMETHODCALLTYPE*/ SetCallback( ISampleGrabberCB pCallback, LONG WhichMethodToCallback );
    }

	/*[
		object,
		uuid(C6E13340-30AC-11d0-A18C-00A0C9118956),
		pointer_default(unique)
	]*/
	// this is the structure returned by a VIDEO filter
	//
	struct VIDEO_STREAM_CONFIG_CAPS {

		GUID        guid;   // will be MEDIATYPE_Video

		// the logical or of all the AnalogVideoStandard's supported
		// typically zero if not supported
		ULONG       VideoStandard;

		// the inherent size of the incoming signal... taken from the input
		// pin for a compressor, or the largest size a capture filter can
		// digitize the signal with every pixel still unique
			SIZE        InputSize;

		// The input of a compressor filter may have to be connected for these
		// to be known

		// smallest rcSrc cropping rect allowed
			SIZE        MinCroppingSize;
		// largest rcSrc cropping rect allowed
			SIZE        MaxCroppingSize;
		// granularity of cropping size - eg only widths a multiple of 4 allowed
			int         CropGranularityX;
			int         CropGranularityY;
		// alignment of cropping rect - eg rect must start on multiple of 4
		int     CropAlignX;
		int     CropAlignY;

		// The input of a compressor filter may have to be connected for these
		// to be known

		// smallest bitmap this pin can produce
			SIZE        MinOutputSize;
		// largest bitmap this pin can produce
			SIZE        MaxOutputSize;
		// granularity of output bitmap size
			int         OutputGranularityX;
			int         OutputGranularityY;
		// !!! what about alignment of rcTarget inside BIH if different?

		// how well can you stretch in the x direction?  0==not at all
		// 1=pixel doubling 2=interpolation(2 taps) 3=better interpolation
		// etc.
		int     StretchTapsX;
		int     StretchTapsY;
		// how well can you shrink in the x direction?  0==not at all
		// 1=pixel doubling 2=interpolation(2 taps) 3=better interpolation
		// etc.
		int     ShrinkTapsX;
		int     ShrinkTapsY;

		// CAPTURE filter only - what frame rates are allowed?
			LONGLONG    MinFrameInterval;
			LONGLONG    MaxFrameInterval;

		// what data rates can this pin produce?
			LONG        MinBitsPerSecond;
			LONG        MaxBitsPerSecond;
	}

	// this is the structure returned by an AUDIO filter
	//
	struct AUDIO_STREAM_CONFIG_CAPS {
		GUID       guid;    // will be MEDIATYPE_Audio
		ULONG      MinimumChannels;
		ULONG      MaximumChannels;
		ULONG      ChannelsGranularity;
		ULONG      MinimumBitsPerSample;
		ULONG      MaximumBitsPerSample;
		ULONG      BitsPerSampleGranularity;
		ULONG      MinimumSampleFrequency;
		ULONG      MaximumSampleFrequency;
		ULONG      SampleFrequencyGranularity;
	}

	interface IAMStreamConfig : IUnknown
	{
		// - only allowed when pin is not streaming, else the call will FAIL
		// - If your output pin is not yet connected, and you can
		//   connect your output pin with this media type, you should
		//   succeed the call, and start offering it first (enumerate as format#0)
		//   from GetMediaType so that this format will be used to connect with
		//   when you do connect to somebody
		// - if your output pin is already connected, and you can provide this
		//   type, reconnect your pin.  If the other pin can't accept it, FAIL
		//   this call and leave your connection alone.
		HRESULT SetFormat(
				/*[in]*/ AM_MEDIA_TYPE *pmt);

		// the format it's connected with, or will connect with
		// the application is responsible for calling DeleteMediaType(*ppmt);
		HRESULT GetFormat(
				/*[out]*/ AM_MEDIA_TYPE **ppmt);

		// how many different Stream Caps structures are there?
		// also, how big is the stream caps structure?
		HRESULT GetNumberOfCapabilities(
				/*[out]*/ int *piCount,
			/*[out]*/ int *piSize); // pSCC of GetStreamCaps needs to be this big

		// - gets one of the pairs of {Mediatype, Caps}
		// - return S_FALSE if iIndex is too high
		// - the application is responsible for calling DeleteMediaType(*ppmt);
		// - the first thing pSCC points to is a GUID saying MEDIATYPE_Video
		//   or MEDIATYPE_Audio, so you can tell if you have a pointer to a
		//   VIDEO_STREAM_CONFIG_CAPS or an AUDIO_STREAM_CONFIG_CAPS structure
		//   There could potentially be many more possibilities other than video
		//   or audio.
		HRESULT GetStreamCaps(
			/*[in]*/  int iIndex,   // 0 to #caps-1
			/*[out]*/ AM_MEDIA_TYPE **ppmt,
				/*[out]*/ BYTE *pSCC);

	}

	/*[
		object,
		uuid(B196B28B-BAB4-101A-B69C-00AA00341D07),
		pointer_default(unique)
	]*/
	alias ISpecifyPropertyPages LPSPECIFYPROPERTYPAGES;

	struct CAUUID {
		ULONG cElems;
		/*[size_is(cElems)]*/ GUID * pElems;
	}

	alias CAUUID* LPCAUUID;

	interface ISpecifyPropertyPages : IUnknown
	{
		HRESULT GetPages(
					/*[out]*/ CAUUID * pPages
				);
	}
}
